<template>
  <v-app app>
    <v-app-bar dark color="primary" app>
      <v-app-bar-nav-icon>
        <v-icon color="white">mdi-arrow-left</v-icon>
      </v-app-bar-nav-icon>
      <v-toolbar-title class="white--text"
      >name
      </v-toolbar-title>
    </v-app-bar>
    <v-container class="fill-height">
      <v-row class="chat fill-height" align="end">
        <v-col>
          <div v-for="(item, index) in chat" :key="index"
               :class="['d-flex flex-row align-center my-6', item.from === 'user' ? 'justify-end': null]">
            <span v-if="item.from === 'user'" class="bg-primary message message_right mr-3">{{ item.msg }}</span>
            <v-avatar :color="item.from === 'user' ? 'primary': 'red'" size="36">
              <span class="white--text">{{ item.from[0] }}</span>
            </v-avatar>
            <span v-if="item.from !== 'user'" class="message message_left ml-3">{{ item.msg }}</span>
          </div>
        </v-col>
      </v-row>
    </v-container>
    <v-footer fixed class="justify-center">
      <v-container class="ma-0 pa-0">
        <v-row no-gutters>
          <v-col>
            <div class="d-flex flex-row align-center justify-center">
              <v-text-field hide-details v-model="msg" placeholder="Type Something" @keypress.enter="send"></v-text-field>
              <v-btn icon class="ml-4" @click="send">
                <v-icon>mdi-send</v-icon>
              </v-btn>
            </div>
          </v-col>
        </v-row>
      </v-container>
    </v-footer>
  </v-app>
</template>

<script>


export default {
  name: "Chat",
  components: {},
  data: () => ({
    chat: [],
    msg: null,
    eventSource: null
  }),
  methods: {
    async send() {
      const payload = {
        conversationId: 1,
        content: this.msg
      }
      // const res = await this.$axios.post('http://localhost:8000/messages/1', payload);
      console.log(res, 'res');
    },
  },
  async mounted() {
    // let url = new URL('http://localhost:3000/.well-known/mercure');
    // url.searchParams.append('topic', `/conversations/1`)
    //
    // const es = new EventSource(url,{
    //   withCredentials: true
    // });
    // es.onmessage = e => {
    //   // Will be called every time an update is published by the server
    //   console.log(JSON.parse(e.data));
    // }
  },
}


</script>

<style lang="scss" scoped>

.chat {
  padding-bottom: 100px;
}

.message {
  color: white;
  display: flex;
  align-items: center;
  text-align: start;
  padding: 12px;
  background-color: #2f4ea5;
  position: relative;
  height: 100%;
  min-height: 50px;

  &:before {
    content: '';
    position: absolute;
    display: block;
    width: 18px;
    height: 18px;
    bottom: 0;
  }

  &_left {
    border-radius: 10px 10px 10px 0;
    &:before {
      left: -13px;
      background: linear-gradient(to top left, #2f4ea5 50%, transparent 50%);
    }
  }

  &_right {
    border-radius: 10px 10px 0 10px;
    &:before {
      right: -13px;
      background: linear-gradient(to top right, #2f4ea5 50%, transparent 50%);
    }
  }
}
</style>
